<?php

namespace Blok\Metatags\Traits;

/**
 * Trait HasMetatags
 * @package Blok\Metatags\Traits
 * @comments Generated by ../../generator.php the 2020-10-13 21:52:01
 */
trait HasMetatags
{
    public $_metatags = [];

    public function getMetaTitle(){
        return $this->_metatags['Title'] ?? null;
    }

    public function setMetaTitle($value){
        $this->_metatags['Title'] = $value;
        return $this;
    }

    public function getMetaDescription(){
        return $this->_metatags['Description'] ?? null;
    }

    public function setMetaDescription($value){
        $this->_metatags['Description'] = $value;
        return $this;
    }

    public function getMetaKeywords(){
        return $this->_metatags['Keywords'] ?? null;
    }

    public function setMetaKeywords($value){
        $this->_metatags['Keywords'] = $value;
        return $this;
    }

    public function getMetaUrl(){
        return $this->_metatags['Url'] ?? null;
    }

    public function setMetaUrl($value){
        $this->_metatags['Url'] = $value;
        return $this;
    }

    public function getMetaIdentifierURL(){
        return $this->_metatags['IdentifierURL'] ?? null;
    }

    public function setMetaIdentifierURL($value){
        $this->_metatags['IdentifierURL'] = $value;
        return $this;
    }

    public function getMetaAuthor(){
        return $this->_metatags['Author'] ?? null;
    }

    public function setMetaAuthor($value){
        $this->_metatags['Author'] = $value;
        return $this;
    }

    public function getMetaCanonical(){
        return $this->_metatags['Canonical'] ?? null;
    }

    public function setMetaCanonical($value){
        $this->_metatags['Canonical'] = $value;
        return $this;
    }

    public function getMetaDcTitle(){
        return $this->_metatags['DcTitle'] ?? null;
    }

    public function setMetaDcTitle($value){
        $this->_metatags['DcTitle'] = $value;
        return $this;
    }

    public function getMetaDcDescription(){
        return $this->_metatags['DcDescription'] ?? null;
    }

    public function setMetaDcDescription($value){
        $this->_metatags['DcDescription'] = $value;
        return $this;
    }

    public function getMetaDcSource(){
        return $this->_metatags['DcSource'] ?? null;
    }

    public function setMetaDcSource($value){
        $this->_metatags['DcSource'] = $value;
        return $this;
    }

    public function getMetaDcCreator(){
        return $this->_metatags['DcCreator'] ?? null;
    }

    public function setMetaDcCreator($value){
        $this->_metatags['DcCreator'] = $value;
        return $this;
    }

    public function getMetaFbPageId(){
        return $this->_metatags['FbPageId'] ?? null;
    }

    public function setMetaFbPageId($value){
        $this->_metatags['FbPageId'] = $value;
        return $this;
    }

    public function getMetaFbAppId(){
        return $this->_metatags['FbAppId'] ?? null;
    }

    public function setMetaFbAppId($value){
        $this->_metatags['FbAppId'] = $value;
        return $this;
    }

    public function getMetaOgTitle(){
        return $this->_metatags['OgTitle'] ?? null;
    }

    public function setMetaOgTitle($value){
        $this->_metatags['OgTitle'] = $value;
        return $this;
    }

    public function getMetaOgDescription(){
        return $this->_metatags['OgDescription'] ?? null;
    }

    public function setMetaOgDescription($value){
        $this->_metatags['OgDescription'] = $value;
        return $this;
    }

    public function getMetaOgUrl(){
        return $this->_metatags['OgUrl'] ?? null;
    }

    public function setMetaOgUrl($value){
        $this->_metatags['OgUrl'] = $value;
        return $this;
    }

    public function getMetaOgImage(){
        return $this->_metatags['OgImage'] ?? null;
    }

    public function setMetaOgImage($value){
        $this->_metatags['OgImage'] = $value;
        return $this;
    }

    public function getMetaOgType(){
        return $this->_metatags['OgType'] ?? null;
    }

    public function setMetaOgType($value){
        $this->_metatags['OgType'] = $value;
        return $this;
    }

    public function getMetaOgLocale(){
        return $this->_metatags['OgLocale'] ?? null;
    }

    public function setMetaOgLocale($value){
        $this->_metatags['OgLocale'] = $value;
        return $this;
    }

    public function getMetaTwitterTitle(){
        return $this->_metatags['TwitterTitle'] ?? null;
    }

    public function setMetaTwitterTitle($value){
        $this->_metatags['TwitterTitle'] = $value;
        return $this;
    }

    public function getMetaTwitterDescription(){
        return $this->_metatags['TwitterDescription'] ?? null;
    }

    public function setMetaTwitterDescription($value){
        $this->_metatags['TwitterDescription'] = $value;
        return $this;
    }

    public function getMetaTwitterImage(){
        return $this->_metatags['TwitterImage'] ?? null;
    }

    public function setMetaTwitterImage($value){
        $this->_metatags['TwitterImage'] = $value;
        return $this;
    }

    public function getMetaTwitterCard(){
        return $this->_metatags['TwitterCard'] ?? null;
    }

    public function setMetaTwitterCard($value){
        $this->_metatags['TwitterCard'] = $value;
        return $this;
    }

    public function getMetaTwitterSite(){
        return $this->_metatags['TwitterSite'] ?? null;
    }

    public function setMetaTwitterSite($value){
        $this->_metatags['TwitterSite'] = $value;
        return $this;
    }

    public function getMetaTwitterCreator(){
        return $this->_metatags['TwitterCreator'] ?? null;
    }

    public function setMetaTwitterCreator($value){
        $this->_metatags['TwitterCreator'] = $value;
        return $this;
    }
    /**
     * @param array $override
     * @return array
     */
    public function getMetatags($override = [])
    {
        return $this->formatMetatags($override);
    }

    /**
     * @param array $override
     * @return array
     */
    public function formatMetatags($override = [])
    {
        $data = [];

        foreach (config('metatags.meta') as $key => $meta) {

            $value = $this->{'getMeta'.ucfirst(camel_case(str_replace(['.', ':', '-', '_'], ' ', $key)))}();

            if(!$value && isset($meta['fallback'])){
                foreach($meta['fallback'] as $k){

                    $value = $this->{'getMeta'.ucfirst(camel_case(str_replace(['.', ':', '-', '_'], ' ', $k)))}();

                    if($value){
                        break;
                    }
                }
            }

            if($value){
                $data[$key] = [
                    $meta['key'] => $key,
                    $meta['value'] =>  $value
                ];
            }
        }

        return array_merge($data, $override);
    }
}
